﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using GrapeCity.Competition.Maze;

namespace GrapeCity.Competition.Maze.Debuger
{
    public partial class ManualControlDialog : Form
    {
        private readonly IExplorer explorer;
        private readonly IMaze maze;

        public ManualControlDialog(IMaze maze, IExplorer explorer)
        {
            InitializeComponent();
            this.maze = maze;
            this.explorer = explorer;
        }

        private void ManualControlDialog_Load(object sender, EventArgs e)
        {
            Text = explorer.Name;
        }

        private void ManualControlDialog_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 'W' || e.KeyChar == 'w')
            {
                explorer.Move(Direction.Up);
                AutoClose();
            }
            else if (e.KeyChar == 'S' || e.KeyChar == 's')
            {
                explorer.Move(Direction.Down);
                AutoClose();
            }
            else if (e.KeyChar == 'A' || e.KeyChar == 'a')
            {
                explorer.Move(Direction.Left);
                AutoClose();
            }
            else if (e.KeyChar == 'D' || e.KeyChar == 'd')
            {
                explorer.Move(Direction.Right);
                AutoClose();
            }
        }

        private void ManualControlDialog_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Up)
            {
                explorer.Move(Direction.Up);
                AutoClose();
            }
            else if (e.KeyCode == Keys.Down)
            {
                explorer.Move(Direction.Down);
                AutoClose();
            }
            else if (e.KeyCode == Keys.Left)
            {
                explorer.Move(Direction.Left);
                AutoClose();
            }
            else if (e.KeyCode == Keys.Right)
            {
                explorer.Move(Direction.Right);
                AutoClose();
            }
        }

        private void AutoClose()
        {
            if(explorer.X == maze.Exit.X && explorer.Y == maze.Exit.Y)
            {
                MessageBox.Show("You slove the maze!!!");
                this.Close();
            }
        }

    }
}
