﻿using System;

using GrapeCity.Competition.Maze.Engine.Maps;

namespace GrapeCity.Competition.Maze.Engine.Elements
{
    #region The Wall class
    /// <summary>
    ///   Represents the element indicate a wall.
    /// </summary>
    [Serializable]
    public class Wall : MazeElement
    {
        #region Constructor
        /// <summary>
        ///   Initialize the <see cref="Wall"/> object.
        /// </summary>
        /// <param name="mazeMap">
        ///   A <see cref="IMazeMap"/> object indicates the maze map.
        /// </param>
        public Wall(IMazeMap mazeMap)
            : base(mazeMap)
        {
        }
        #endregion

        #region Clone
        /// <summary>
        ///   Creates a new object that is a copy of the current instance.
        /// </summary>
        /// <returns>
        ///   A new object that is a copy of this instance.
        /// </returns>
        public override MazeElement Clone(IMazeMap map)
        {
            return new Wall(map);
        }
        #endregion

        #region Properties
        /// <summary>
        ///   Gets the information in the position.
        /// </summary>
        /// <value>
        ///   A <see cref="PositionInfo"/> value indicates the position information.
        /// </value>
        public override PositionInfo ElementInfo
        {
            get
            {
                return PositionInfo.Wall;
            }
        }
        #endregion
    }
    #endregion
}