﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GrapeCity.Competition.Maze.Engine.Maps
{
    #region The IMazeMapEditor interface

    /// <summary>
    ///   Represents a maze map editor.
    /// </summary>
    public interface IMazeMapEditor : IMazeMap
    {
        /// <summary>
        ///   Set the element on specified position.
        /// </summary>
        /// <param name="position">
        ///   A <see cref="IPosition"/> value indicates the specified position.
        /// </param>
        /// <param name="element">
        ///   A <see cref="MazeElement"/> object indicates the element.
        /// </param>
        void SetElement(IPosition position, MazeElement element);

        /// <summary>
        ///   Set the element on specified position.
        /// </summary>
        /// <param name="x">
        ///   The x-coordinate of the upper-left corner of the element to set. 
        /// </param>
        /// <param name="y">
        ///  The y-coordinate of the upper-left corner of the element to set. 
        /// </param>
        /// <param name="element">
        ///   A <see cref="MazeElement"/> object indicates the element.
        /// </param>
        void SetElement(int x, int y, MazeElement element);
    }

    #endregion
}
