﻿using System.Collections.Generic;
using GrapeCity.Competition.Maze.Engine.Explorers;
using GrapeCity.Competition.Maze.Engine.Maps;

namespace GrapeCity.Competition.Maze.Engine
{
    public class Maze2D
    {
        private readonly MazeMap staticMap;
        private MazeMap dynamicMap;

        private readonly Dictionary<string, MazeExplorer> explorers;
        private readonly Dictionary<string, Thinker> thinkers;

        protected MazeMap StaticMap
        {
            get { return staticMap; }
        }

        protected MazeMap Map
        {
            get { return dynamicMap; }
        }

        protected IDictionary<string, MazeExplorer> Explorers
        {
            get { return explorers; }
        }

        protected IDictionary<string, Thinker> Thinkers
        {
            get { return thinkers; }
        }

        protected Maze2D(MazeMap mazeMap)
        {
            this.staticMap = mazeMap;
            this.dynamicMap = this.staticMap.Clone() as MazeMap;

            this.explorers = new Dictionary<string, MazeExplorer>();
            this.thinkers = new Dictionary<string, Thinker>();
        }

        public IPosition Exit
        {
            get { return Map.Exit; }
        }

        public string Name
        {
            get { return staticMap.Name; }
        }

        public int Width
        {
            get { return staticMap.Width; }
        }

        public int Height
        {
            get { return staticMap.Height; }
        }
        
        protected void ResetMap()
        {
            this.explorers.Clear();
            this.thinkers.Clear();
            this.dynamicMap = this.staticMap.Clone() as MazeMap;
        }
    }
}

