﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using GrapeCity.Competition.Maze.Engine;
using GrapeCity.Competition.Maze.Engine.Elements;
using GrapeCity.Competition.Maze.Engine.Maps;

namespace GrapeCity.Competition.Maze.Generators
{
    [Name("Util -> Grid Node")]
    [Author("GrapeCity")]
    public class GridNodeGen : IMazeMapGenerator
    {
        public void SetupRenderSupport(Control screen)
        {
        }

        public void SetupSkinSupport(IMazeSkin skin)
        {
        }

        public bool Generate(int seed, IMazeMapEditor mapEditor)
        {
            (new WallGen()).Generate(0, mapEditor);

            MapUtil map = new MapUtil(mapEditor);

            //building graph nodes.
            Position[,] graphNodes = GridGen.GetGraphNodes(map.Width, map.Height);

            //hole graph nodes.
            foreach (Position node in graphNodes)
            {
                if (map.IsExit(node) || map.IsEntrance(node)) continue;
                map.SetElement(node, new Path(mapEditor));
            }

            return true;
        }
    }
}
