﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GrapeCity.Competition.Maze.Generators
{
    internal class RandomUtil
    {
        private readonly Random rnd;

        internal RandomUtil(int seed)
        {
            rnd = new Random(seed);
        }

        internal RandomUtil(Random random)
        {
            rnd = random;
        }

        internal IPosition NextPosition(IPosition[] list)
        {
            if (list == null) return null;
            if (list.Length == 1) return list[0];

            int hit = rnd.Next(0, list.Length);
            return list[hit];
        }

        internal Position NextPosition(IList<Position> list)
        {
            if (list == null) return Position.Zero;
            if (list.Count == 1) return list[0];

            int hit = rnd.Next(0, list.Count);
            return list[hit];
        }

        internal Direction NextDirection(Direction[] list)
        {
            if (list == null) return Direction.None;
            if (list.Length == 1) return list[0];

            int hit = rnd.Next(0, list.Length);
            return list[hit];
        }

        internal Direction NextDirection()
        {
            int hit = rnd.Next(0, 4);
            return (Direction)hit;
        }

        internal int Next(int[] list)
        {
            return list[rnd.Next(0, list.Length)];
        }

        internal int Next(int min, int max)
        {
            return rnd.Next(min, max);
        }

        internal int Next()
        {
            return rnd.Next();
        }

        internal bool NextBoolean()
        {
            return rnd.Next(1, 100) > 50 ? true : false;
        }

        internal T[] RandomArray<T>(T[] array)
        {
            List<T> list = new List<T>();

            while(list.Count < array.Length)
            {
                int hit = rnd.Next(0, array.Length);
                if(!list.Contains(array[hit]))
                    list.Add(array[hit]);
            }

            return list.ToArray();
        }
    }
}
