﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using GrapeCity.Competition.Maze.Engine;
using GrapeCity.Competition.Maze.Engine.Elements;
using GrapeCity.Competition.Maze.Engine.Maps;

namespace GrapeCity.Competition.Maze.Generators
{
    [Name("Util -> Reverse")]
    [Author("GrapeCity")]
    public class ReverseGen : IMazeMapGenerator
    {
        public void SetupRenderSupport(Control screen)
        {
        }

        public void SetupSkinSupport(IMazeSkin skin)
        {
        }

        public bool Generate(int seed, IMazeMapEditor map)
        {
            int width = map.Width;
            int height = map.Height;

            for (int y = 0; y < height; y++)
            {
                for (int x = 0; x < width; x++)
                {
                    if (map.GetElement(x, y) is Path)
                    {
                        map.SetElement(x, y, new Wall(map));
                    }
                    else if (map.GetElement(x, y) is Wall)
                    {
                        map.SetElement(x, y, new Path(map));
                    }
                }
            }

            return true;
        }
    }
}
