﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using GrapeCity.Competition.Maze.Engine;
using GrapeCity.Competition.Maze.Engine.Elements;
using GrapeCity.Competition.Maze.Engine.Maps;

namespace GrapeCity.Competition.Maze.Generators
{
    [Name("Lv1. Random Map")]
    [Author("GrapeCity")]
    public class SimpleRandomMapGen : IMazeMapGenerator
    {
        #region IMazeMapGenerator Members

        public void SetupRenderSupport(Control screen)
        {
        }

        public void SetupSkinSupport(IMazeSkin skin)
        {
        }

        public bool Generate(int seed, IMazeMapEditor map)
        {
            try
            {
                if (map == null) return false;

                Random rnd = new Random(seed);
                int width = map.Width;
                int height = map.Height;
                for (int y = 0; y < height; y++)
                {
                    for (int x = 0; x < width; x++)
                    {
                        if(x == map.Entrance.X && y == map.Entrance.Y)
                        {
                           continue;
                        }
                        else if (x == map.Exit.X && y == map.Exit.Y)
                        {
                            continue;
                        }
                        else
                        {
                            int wallOrPath = rnd.Next(100);
                            if (wallOrPath > 75)
                            {
                                map.SetElement(x, y, new Wall(map));
                            }
                            else
                            {
                                map.SetElement(x, y, new Path(map));
                            }
                        }
                    }
                }

                return true;
            }
            catch
            {
                return false;
            }
        }

        #endregion
    }
}