﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GrapeCity.Competition.Maze
{
    /// <summary>
    ///   Represents the direction information.
    /// </summary>
    /// <example>
    /// <code>  
    ///  public void Think(IMaze maze, IExplorer explorer)
    ///  {
    ///     if(explorer.Look(Direction.Up) == PositionInfo.Path)
    ///     {
    ///         explorer.Move(Direction.Up);
    ///     }
    ///  }
    /// </code>
    /// </example>
    public enum Direction
    {
        /// <summary>
        ///  Specifies that the direction is left.
        /// </summary>
        Left = 0,

        /// <summary>
        ///  Specifies that the direction is right.
        /// </summary>
        Right = 1,

        /// <summary>
        ///  Specifies that the direction is up.
        /// </summary>
        Up = 2,

        /// <summary>
        ///  Specifies that the direction is down.
        /// </summary>
        Down = 3,

        /// <summary>
        ///  Specifies that the direction is origin.
        /// </summary>
        None = 4,
    }
}
