﻿using System;

namespace GrapeCity.Competition.Maze
{
    #region The IMaze interface
    /// <summary>
    ///   Represents the basic information of maze.
    /// </summary>
    public interface IMaze
    {
        /// <summary>
        ///   Gets the maze name.
        /// </summary>
        /// <value>
        ///   A <b>string</b> value indicates the maze name.
        /// </value>
        string Name { get; }

        /// <summary>
        ///   Gets the width of maze.
        /// </summary>
        /// <value>
        ///   An <b>int</b> value indicates the maze width.
        /// </value>
        int Width { get; }

        /// <summary>
        ///   Gets the height of maze.
        /// </summary>
        /// <value>
        ///   An <b>int</b> value indicates the maze height.
        /// </value>
        int Height { get; }

        /// <summary>
        ///   Gets the entrance position of maze.
        /// </summary>
        /// <value>
        ///   An <see cref="IPosition"/> value indicates the entrance position of maze.
        /// </value>
        IPosition Entrance { get; }

        /// <summary>
        ///   Gets the exit position of maze.
        /// </summary>
        /// <value>
        ///   An <see cref="IPosition"/> value indicates the exit position of maze.
        /// </value>
        IPosition Exit { get; }
    }
    #endregion
}
