﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GrapeCity.Competition.Maze
{
    /// <summary>
    /// Marks each type of position that is defined as a derived class of MazeElement.
    /// </summary>
    public enum PositionInfo
    {
        /// <summary>
        /// Specifies that the member is an unknown object.
        /// </summary>
        Unknown = 0,
        
        /// <summary>
        /// Specifies that the member is an entrance.
        /// </summary>
        Entrance = 1,

        /// <summary>
        /// Specifies that the member is an exit.
        /// </summary>
        Exit = 2,

        /// <summary>
        /// Specifies that the member is a path.
        /// </summary>
        Path = 3,

        /// <summary>
        /// Specifies that the member is a wall.
        /// </summary>
        Wall = 4,

        /// <summary>
        /// Specifies that the member is a door.
        /// </summary>
        Door = 5,

        /// <summary>
        /// Specifies that the member is a trigger.
        /// </summary>
        Trigger = 6,

        /// <summary>
        /// Specifies that the member is a treasure.
        /// </summary>
        Treasure = 7,

        /// <summary>
        /// Specifies that the member is a danger.
        /// </summary>
        Danger = 8,

        /// <summary>
        /// Specifies that the member is a transport.
        /// </summary>
        Transport = 9,
    }
}
