﻿using System;
using System.Collections.Generic;
using System.Text;
using GrapeCity.Competition.Maze.Engine;
using GrapeCity.Competition.Maze.Engine.Explorers;

namespace GrapeCity.Competition.Maze
{
    internal class MazePlayerStatus : IPosition
    {
        private readonly string name;
        private readonly int steps;
        private readonly int looks;
        private readonly int blocks;
        private readonly Position pos;

        internal MazePlayerStatus(IMazeExplorer e)
        {
            name = e.Name;
            steps = e.Steps;
            looks = e.Looks;
            blocks = e.Blocks;
            pos = new Position(e);
        }

        internal int Steps
        {
            get { return steps; }
        }

        internal int Looks
        {
            get { return looks; }
        }

        internal int Blocks
        {
            get { return blocks; }
        }

        public int X
        {
            get { return pos.X; }
        }

        public int Y
        {
            get { return pos.Y; }
        }

        public string Name
        {
            get { return name; }
        }
    }
}
