﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using GrapeCity.Competition.Maze.EmbeddedEngine;

namespace GrapeCity.Competition.Maze.UI
{
    internal partial class BlockColorDialog : Form
    {
        private readonly MazeSkin skin;

        internal BlockColorDialog(MazeSkin skin)
        {
            InitializeComponent();
            this.skin = skin;
        }

        private void BlockColorDialog_Load(object sender, EventArgs e)
        {
            this.LoadColors();
        }

        private void LoadColors()
        {
            colorPath.SelectedColor = skin[MazeSkin.Color_Path];
            colorTrigger.SelectedColor = skin[MazeSkin.Color_Trigger];
            colorWall.SelectedColor = skin[MazeSkin.Color_Wall];
            colorExplorer.SelectedColor = skin[MazeSkin.Color_Explorer];

            colorExit.SelectedColor = skin[MazeSkin.Color_Exit];
            colorEntrance.SelectedColor = skin[MazeSkin.Color_Entrance];
            colorDoorOpen.SelectedColor = skin[MazeSkin.Color_DoorOpen];
            colorDoorLocked.SelectedColor = skin[MazeSkin.Color_DoorClose];

            colorTransport.SelectedColor = skin[MazeSkin.Color_Transport];
        }

        private void SaveColors()
        {
            skin[MazeSkin.Color_Path] = colorPath.SelectedColor;
            skin[MazeSkin.Color_Trigger] = colorTrigger.SelectedColor;
            skin[MazeSkin.Color_Wall] = colorWall.SelectedColor;
            skin[MazeSkin.Color_Explorer] = colorExplorer.SelectedColor;

            skin[MazeSkin.Color_Exit] = colorExit.SelectedColor;
            skin[MazeSkin.Color_Entrance] = colorEntrance.SelectedColor;
            skin[MazeSkin.Color_DoorOpen] = colorDoorOpen.SelectedColor;
            skin[MazeSkin.Color_DoorClose] = colorDoorLocked.SelectedColor;

            skin[MazeSkin.Color_Transport] = colorTransport.SelectedColor;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.SaveColors();
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void buttonReset_Click(object sender, EventArgs e)
        {
            skin.ResetColor();
            this.LoadColors();
        }

    }
}
